/*
 * v0 : IR et Discord
 * Au départ , led bleue allumée durant TEMPSPOURSORTIR minutes.
 * Ensuite clignote bleu si detection et envoi un message.
 * Attend au moins TEMPSAPRESALARME avant d'envoyer une autre alerte
 * ESP8266 compilation: Choisissez NodeMCU 1.0
*/

//********** Paramètres ***************
// Pin D7 = GPIO13 sur NodeMCU
#define SENSORPIN 13 
// LED_BUILTIN = 2 pour LoLin NodeMCU
#define LED_BUILTIN 2
// 120000 (ms) : 2 minutes pour quitter la maison lors de l'activation
#define TEMPSPOURSORTIR  120000
#define TEMPSAPRESALARME 120000

#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
// For Https + Multi SSID
ESP8266WiFiMulti WiFiMulti;
wl_status_t LastWifiState = WL_IDLE_STATUS;
WiFiClient client;

void setup()
{  
   Serial.begin(115200);
   // ----------------- Init sensors -----------------------
   pinMode(SENSORPIN, INPUT); // declare sensor comme input
   pinMode(LED_BUILTIN, OUTPUT); 
   // ---------------- Init network ----------------------------
   Serial.println("Start WIFI_STA");
   delay(2000);

   WiFi.mode(WIFI_STA);
   // Mettre vos wifi. On peut en mettre plusieurs.
   WiFiMulti.addAP("nom_du_wifi",       "clef-du-wifi");
   // Ajouter d'autres Wifi ici
   delay(1000);
   
   // ---------------- Attente le temps de quitter la pièce --------------
   digitalWrite(LED_BUILTIN, LOW);   // LED on   
   delay(TEMPSPOURSORTIR);
   digitalWrite(LED_BUILTIN, HIGH);  // LED off
   if ((WiFiMulti.run() == WL_CONNECTED)) {Serial.println("Connected");}
   else {Serial.println("Connection failed");}
}

void loop()
{
  long state;
  state = digitalRead(SENSORPIN); // etat du capteur
  if (state == HIGH)              // detection !!
     {
      digitalWrite(LED_BUILTIN, LOW);   // LED on
      sendAlertDISCORD();
      delay(TEMPSAPRESALARME);  // rien pendant 2 minutes
      digitalWrite(LED_BUILTIN, HIGH);   // LED off
     }
}

void sendAlertDISCORD()
  {
    const char* serverName = "https://discordapp.com/api/channels/mon-channel-id/messages";
    // test WiFi connection
    if ((WiFiMulti.run() == WL_CONNECTED))
      {
      // ignore SSL certificate
      std::unique_ptr<BearSSL::WiFiClientSecure> client(new BearSSL::WiFiClientSecure);
      client->setInsecure();
      HTTPClient http;
      http.begin(*client,serverName);
      http.addHeader("Authorization", "Bot mon-token");
      http.addHeader("User-Agent", "myBotThing (http://some.url, v0.1)");
      http.addHeader("Content-Type", "application/json");
      int httpCode = http.POST( "{\"content\": \"ALARME\"}" );
  
      // httpCode will be negative on error
      if (httpCode > 0) 
        {
        // HTTP header has been send and Server response header has been handled
        Serial.printf("[HTTP] GET... code: %d\n", httpCode);  
        // file found at server
        if ((httpCode == HTTP_CODE_OK) || (httpCode == HTTP_CODE_CREATED))
            {
            String payload = http.getString();
            Serial.println(payload);
            }
        } 
      else
        {
        Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
        }
      http.end();
      }
  }



